unit ObjetTrombinoscope;

interface
uses System.SysUtils // ncessaire pour obtenir la date systme, le type TFileName
     ,System.Generics.Collections  // ncessaire pour la dclaration de liste d'objets
     ,System.Generics.Defaults
     ,System.Classes
     ,VCL.Graphics
     ,Jpeg, pngimage, GIFImg ; // tout type d'image

type
  TTronche = Class
  strict private
    FContactName1 : String;
    FDateField1 : TDate;
    FContactBitmap1 : TPicture;
  private
  public
    constructor Create(); overload;
    constructor Create(Nom : String; UneDate : TDate); overload;
    constructor Create(Nom : String; UneDate : TDate; Image : TFileName); overload;
    property ContactName1 : String read FContactName1;
    property DateField1 : TDate read FDateField1;
    property ContactBitmap1 : TPicture read FContactBitmap1;
  end;

  procedure easteregg;

  var MesTronches : TObjectList<TTronche>;

implementation

{ TTronche }

constructor TTronche.Create;
// cration par dfaut
begin
FContactName1 :='<Nom>';
FDateField1 := now;
end;

constructor TTronche.Create(Nom: String; UneDate: TDate);
begin
FContactName1 :=Nom;
FDateField1 := UneDate;
end;

constructor TTronche.Create(Nom: String; UneDate: TDate; Image: TFileName);
begin
FContactName1 :=Nom;
FDateField1 := UneDate;
FContactBitmap1:=TPicture.Create;
 try
  FContactBitmap1.LoadFromFile(Image);
 except

 end;
end;


procedure easteregg;
// Chargement de valeurs internes
begin
  MesTronches.Add(TTronche.Create('Sergio Master (gif)',EncodeDate(2007,01,22),'g:\presentation\demos\einstein.gif'));
  MesTronches.Add(TTronche.Create('Avatar Druide (png)',Date,'g:\presentation\demos\druide.png'));
  MesTronches.Add(TTronche.Create('Ours (bmp)',Date,'g:\presentation\demos\ours.bmp'));
  MesTronches.Add(TTronche.Create('Lion de Mer (bmp)',Date,'g:\presentation\demos\lion.bmp'));
  MesTronches.Add(TTronche.Create('Serge Girard (jpg)',EncodeDate(1956,6,29),'g:\presentation\demos\moi.jpg'));
end;

initialization
MesTronches:=TObjectList<TTronche>.Create();
end.
